var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { h, r as registerInstance, c as createEvent, g as getAssetPath } from './core-6e732d03.js';
/* tslint:disable:no-bitwise */
var Base64 = /** @class */ (function () {
    function Base64() {
    }
    // base64 is 4/3 + up to two characters of the original data
    Base64.byteLength = function (b64) {
        var _a = Base64._getLengths(b64), validLength = _a[0], placeHoldersLength = _a[1];
        return Base64._byteLength(validLength, placeHoldersLength);
    };
    Base64.decode = function (b64) {
        Base64._initRevLookup();
        var _a = Base64._getLengths(b64), validLength = _a[0], placeHoldersLength = _a[1];
        var arr = new Uint8Array(Base64._byteLength(validLength, placeHoldersLength));
        var curByte = 0;
        // if there are placeholders, only get up to the last complete 4 chars
        var len = placeHoldersLength > 0 ? validLength - 4 : validLength;
        var i = 0;
        for (; i < len; i += 4) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 18) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] << 12) |
                (Base64._revLookup[b64.charCodeAt(i + 2)] << 6) |
                Base64._revLookup[b64.charCodeAt(i + 3)];
            arr[curByte++] = (tmp >> 16) & 0xFF;
            arr[curByte++] = (tmp >> 8) & 0xFF;
            arr[curByte++] = tmp & 0xFF;
        }
        if (placeHoldersLength === 2) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 2) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] >> 4);
            arr[curByte++] = tmp & 0xFF;
        }
        if (placeHoldersLength === 1) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 10) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] << 4) |
                (Base64._revLookup[b64.charCodeAt(i + 2)] >> 2);
            arr[curByte++] = (tmp >> 8) & 0xFF;
            arr[curByte /*++ not needed*/] = tmp & 0xFF;
        }
        return arr;
    };
    Base64.encode = function (uint8) {
        var length = uint8.length;
        var extraBytes = length % 3; // if we have 1 byte left, pad 2 bytes
        var parts = [];
        var maxChunkLength = 16383; // must be multiple of 3
        // go through the array every three bytes, we'll deal with trailing stuff later
        for (var i = 0, len2 = length - extraBytes; i < len2; i += maxChunkLength) {
            parts.push(Base64._encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
        }
        // pad the end with zeros, but make sure to not forget the extra bytes
        if (extraBytes === 1) {
            var tmp = uint8[length - 1];
            parts.push(Base64._lookup[tmp >> 2] +
                Base64._lookup[(tmp << 4) & 0x3F] +
                '==');
        }
        else if (extraBytes === 2) {
            var tmp = (uint8[length - 2] << 8) + uint8[length - 1];
            parts.push(Base64._lookup[tmp >> 10] +
                Base64._lookup[(tmp >> 4) & 0x3F] +
                Base64._lookup[(tmp << 2) & 0x3F] +
                '=');
        }
        return parts.join('');
    };
    Base64.encodeUrl = function (buffer) {
        return Base64.encode(buffer).replace(/\//g, '_').replace(/\+/g, '-').replace(/=/g, '.');
    };
    Base64.decodeUrl = function (base64) {
        return Base64.decode(base64.replace(/_/g, '/').replace(/-/g, '+').replace(/\./g, '='));
    };
    Base64._initRevLookup = function () {
        if (Base64._revLookup.length !== 0)
            return;
        Base64._revLookup = [];
        for (var i = 0, len = Base64._lookup.length; i < len; i++) {
            Base64._revLookup[Base64._lookup.charCodeAt(i)] = i;
        }
        // Support decoding URL-safe base64 strings, as Node.js does.
        // See: https://en.wikipedia.org/wiki/Base64#URL_applications
        Base64._revLookup['-'.charCodeAt(0)] = 62;
        Base64._revLookup['_'.charCodeAt(0)] = 63;
    };
    Base64._getLengths = function (b64) {
        var length = b64.length;
        if (length % 4 > 0) {
            throw new Error('Invalid string. Length must be a multiple of 4');
        }
        // Trim off extra bytes after placeholder bytes are found
        // See: https://github.com/beatgammit/base64-js/issues/42
        var validLength = b64.indexOf('=');
        if (validLength === -1)
            validLength = length;
        var placeHoldersLength = validLength === length ? 0 : 4 - (validLength % 4);
        return [validLength, placeHoldersLength];
    };
    Base64._byteLength = function (validLength, placeHoldersLength) {
        return ((validLength + placeHoldersLength) * 3 / 4) - placeHoldersLength;
    };
    Base64._tripletToBase64 = function (num) {
        return Base64._lookup[num >> 18 & 0x3F] +
            Base64._lookup[num >> 12 & 0x3F] +
            Base64._lookup[num >> 6 & 0x3F] +
            Base64._lookup[num & 0x3F];
    };
    Base64._encodeChunk = function (uint8, start, end) {
        var output = [];
        for (var i = start; i < end; i += 3) {
            var tmp = ((uint8[i] << 16) & 0xFF0000) +
                ((uint8[i + 1] << 8) & 0xFF00) +
                (uint8[i + 2] & 0xFF);
            output.push(Base64._tripletToBase64(tmp));
        }
        return output.join('');
    };
    return Base64;
}());
Base64._lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
Base64._revLookup = [];
var ExtraJSONTypes;
(function (ExtraJSONTypes) {
    ExtraJSONTypes[ExtraJSONTypes["UINT8_ARRAY"] = 0] = "UINT8_ARRAY";
})(ExtraJSONTypes || (ExtraJSONTypes = {}));
var JSONUtils = /** @class */ (function () {
    function JSONUtils() {
    }
    JSONUtils.stringify = function (value) {
        return JSON.stringify(value, JSONUtils._jsonifyType);
    };
    JSONUtils.parse = function (value) {
        return JSON.parse(value, JSONUtils._parseType);
    };
    JSONUtils._parseType = function (key, value) {
        if (value && value.hasOwnProperty &&
            value.hasOwnProperty(JSONUtils.TYPE_SYMBOL) && value.hasOwnProperty(JSONUtils.VALUE_SYMBOL)) {
            switch (value[JSONUtils.TYPE_SYMBOL]) {
                case ExtraJSONTypes.UINT8_ARRAY:
                    return Base64.decode(value[JSONUtils.VALUE_SYMBOL]);
            }
        }
        return value;
    };
    JSONUtils._jsonifyType = function (key, value) {
        if (value instanceof Uint8Array) {
            return JSONUtils._typedObject(ExtraJSONTypes.UINT8_ARRAY, Base64.encode(value));
        }
        return value;
    };
    JSONUtils._typedObject = function (type, value) {
        var obj = {};
        obj[JSONUtils.TYPE_SYMBOL] = type;
        obj[JSONUtils.VALUE_SYMBOL] = value;
        return obj;
    };
    return JSONUtils;
}());
JSONUtils.TYPE_SYMBOL = '__';
JSONUtils.VALUE_SYMBOL = 'v';
var RandomUtils = /** @class */ (function () {
    function RandomUtils() {
    }
    RandomUtils.generateRandomId = function () {
        var array = new Uint32Array(1);
        crypto.getRandomValues(array);
        return array[0];
    };
    return RandomUtils;
}());
var ResponseStatus;
(function (ResponseStatus) {
    ResponseStatus["OK"] = "ok";
    ResponseStatus["ERROR"] = "error";
})(ResponseStatus || (ResponseStatus = {}));
var POSTMESSAGE_RETURN_URL = '<postMessage>';
var RequestIdStorage = /** @class */ (function () {
    /**
     * @param storeState Whether to store state in sessionStorage
     */
    function RequestIdStorage(storeState) {
        if (storeState === void 0) { storeState = true; }
        this._store = storeState ? window.sessionStorage : null;
        this._validIds = new Map();
        if (storeState) {
            this._restoreIds();
        }
    }
    RequestIdStorage._decodeIds = function (ids) {
        var obj = JSONUtils.parse(ids);
        var validIds = new Map();
        for (var _i = 0, _a = Object.keys(obj); _i < _a.length; _i++) {
            var key = _a[_i];
            var integerKey = parseInt(key, 10);
            validIds.set(isNaN(integerKey) ? key : integerKey, obj[key]);
        }
        return validIds;
    };
    RequestIdStorage.prototype.has = function (id) {
        return this._validIds.has(id);
    };
    RequestIdStorage.prototype.getCommand = function (id) {
        var result = this._validIds.get(id);
        return result ? result[0] : null;
    };
    RequestIdStorage.prototype.getState = function (id) {
        var result = this._validIds.get(id);
        return result ? result[1] : null;
    };
    RequestIdStorage.prototype.add = function (id, command, state) {
        if (state === void 0) { state = null; }
        this._validIds.set(id, [command, state]);
        this._storeIds();
    };
    RequestIdStorage.prototype.remove = function (id) {
        this._validIds.delete(id);
        this._storeIds();
    };
    RequestIdStorage.prototype.clear = function () {
        this._validIds.clear();
        if (this._store) {
            this._store.removeItem(RequestIdStorage.KEY);
        }
    };
    RequestIdStorage.prototype._encodeIds = function () {
        var obj = Object.create(null);
        for (var _i = 0, _a = this._validIds; _i < _a.length; _i++) {
            var _b = _a[_i], key = _b[0], value = _b[1];
            obj[key] = value;
        }
        return JSONUtils.stringify(obj);
    };
    RequestIdStorage.prototype._restoreIds = function () {
        var requests = this._store.getItem(RequestIdStorage.KEY);
        if (requests) {
            this._validIds = RequestIdStorage._decodeIds(requests);
        }
    };
    RequestIdStorage.prototype._storeIds = function () {
        if (this._store) {
            this._store.setItem(RequestIdStorage.KEY, this._encodeIds());
        }
    };
    return RequestIdStorage;
}());
RequestIdStorage.KEY = 'rpcRequests';
var UrlRpcEncoder = /** @class */ (function () {
    function UrlRpcEncoder() {
    }
    UrlRpcEncoder.receiveRedirectCommand = function (location) {
        var url = new URL(location.href);
        // Need referrer for origin check
        if (!document.referrer)
            return null;
        var referrer = new URL(document.referrer);
        // Parse query
        var params = new URLSearchParams(url.search);
        var fragment = new URLSearchParams(url.hash.substring(1));
        // Ignore messages without an ID
        if (!fragment.has('id'))
            return null;
        var id = parseInt(fragment.get('id'), 10);
        fragment.delete('id');
        params.set(UrlRpcEncoder.URL_SEARCHPARAM_NAME, id.toString());
        // Ignore messages without a command
        if (!fragment.has('command'))
            return null;
        var command = fragment.get('command');
        fragment.delete('command');
        // Ignore messages without a valid return path
        if (!fragment.has('returnURL'))
            return null;
        var returnURL = fragment.get('returnURL');
        fragment.delete('returnURL');
        var answerByPostMessage = returnURL === POSTMESSAGE_RETURN_URL
            && (window.opener || window.parent);
        // Only allow returning to same origin
        if (!answerByPostMessage && new URL(returnURL).origin !== referrer.origin)
            return null;
        // Parse args
        var args = [];
        if (fragment.has('args')) {
            try {
                args = JSONUtils.parse(fragment.get('args'));
            }
            catch (e) {
                // Do nothing
            }
        }
        args = Array.isArray(args) ? args : [];
        fragment.delete('args');
        url.search = params.toString();
        this._setUrlFragment(url, fragment);
        history.replaceState(history.state, '', url.href);
        return {
            origin: referrer.origin,
            data: {
                id: id,
                command: command,
                args: args,
            },
            returnURL: returnURL,
            source: answerByPostMessage ? (window.opener || window.parent) : null,
        };
    };
    UrlRpcEncoder.receiveRedirectResponse = function (location) {
        var url = new URL(location.href);
        // Need referrer for origin check
        if (!document.referrer)
            return null;
        var referrer = new URL(document.referrer);
        // Parse query
        var params = new URLSearchParams(url.search);
        var fragment = new URLSearchParams(url.hash.substring(1));
        // Ignore messages without an ID
        if (!fragment.has('id'))
            return null;
        var id = parseInt(fragment.get('id'), 10);
        fragment.delete('id');
        params.set(UrlRpcEncoder.URL_SEARCHPARAM_NAME, id.toString());
        // Ignore messages without a status
        if (!fragment.has('status'))
            return null;
        var status = fragment.get('status') === ResponseStatus.OK ? ResponseStatus.OK : ResponseStatus.ERROR;
        fragment.delete('status');
        // Ignore messages without a result
        if (!fragment.has('result'))
            return null;
        var result = JSONUtils.parse(fragment.get('result'));
        fragment.delete('result');
        url.search = params.toString();
        this._setUrlFragment(url, fragment);
        history.replaceState(history.state, '', url.href);
        return {
            origin: referrer.origin,
            data: {
                id: id,
                status: status,
                result: result,
            },
        };
    };
    UrlRpcEncoder.prepareRedirectReply = function (state, status, result) {
        var returnUrl = new URL(state.returnURL);
        var fragment = new URLSearchParams(returnUrl.hash.substring(1));
        fragment.set('id', state.id.toString());
        fragment.set('status', status);
        fragment.set('result', JSONUtils.stringify(result));
        returnUrl.hash = fragment.toString();
        return returnUrl.href;
    };
    UrlRpcEncoder.prepareRedirectInvocation = function (targetURL, id, returnURL, command, args) {
        var targetUrl = new URL(targetURL);
        var fragment = new URLSearchParams(targetUrl.hash.substring(1));
        fragment.set('id', id.toString());
        fragment.set('returnURL', returnURL);
        fragment.set('command', command);
        if (Array.isArray(args)) {
            fragment.set('args', JSONUtils.stringify(args));
        }
        targetUrl.hash = fragment.toString();
        return targetUrl.href;
    };
    UrlRpcEncoder._setUrlFragment = function (url, fragment) {
        /*
        The Url might include a fragment on its own before adding the parameters to it.
        It might even have a fragment consisting of other parameters.
        A '=' at the last position of the remaining fragment string indicates that at least one fragment
        part is remaining. Since URLSearchParams will try to represent a key=value pair with the value
        missing the '=' is added.
        Unfortunately fragments (as in regular fragment, not parameters) ending in a '=' will not
        work with this implementation. All other fragments, including other sets of parameters should be
        preserved by removing the '=' in case it exists at the end of the fragment. However, if other
        parameters are used without values (i.e. #abc&123&value) they will now include a '=' except
        for the last one (i.e. #abc=&123=&value), which is a valid input to URLSearchParams.
        */
        if (fragment.toString().endsWith('=')) {
            url.hash = fragment.toString().slice(0, -1);
        }
        else {
            url.hash = fragment.toString();
        }
    };
    return UrlRpcEncoder;
}());
UrlRpcEncoder.URL_SEARCHPARAM_NAME = 'rpcId';
var RpcClient = /** @class */ (function () {
    function RpcClient(allowedOrigin, storeState) {
        if (storeState === void 0) { storeState = false; }
        this._allowedOrigin = allowedOrigin;
        this._waitingRequests = new RequestIdStorage(storeState);
        this._responseHandlers = new Map();
        this._preserveRequests = false;
    }
    RpcClient.prototype.onResponse = function (command, resolve, reject) {
        this._responseHandlers.set(command, { resolve: resolve, reject: reject });
    };
    RpcClient.prototype._receive = function (message) {
        // Discard all messages from unwanted sources
        // or which are not replies
        // or which are not from the correct origin
        if (!message.data
            || !message.data.status
            || !message.data.id
            || (this._allowedOrigin !== '*' && message.origin !== this._allowedOrigin))
            return false;
        var data = message.data;
        var callback = this._getCallback(data.id);
        var state = this._waitingRequests.getState(data.id);
        if (callback) {
            if (!this._preserveRequests) {
                this._waitingRequests.remove(data.id);
                this._responseHandlers.delete(data.id);
            }
            console.debug('RpcClient RECEIVE', data);
            if (data.status === ResponseStatus.OK) {
                callback.resolve(data.result, data.id, state);
            }
            else if (data.status === ResponseStatus.ERROR) {
                var error = new Error(data.result.message);
                if (data.result.stack) {
                    error.stack = data.result.stack;
                }
                if (data.result.name) {
                    error.name = data.result.name;
                }
                callback.reject(error, data.id, state);
            }
            return true;
        }
        else {
            console.warn('Unknown RPC response:', data);
            return false;
        }
    };
    RpcClient.prototype._getCallback = function (id) {
        // Response handlers by id have priority to more general ones by command
        if (this._responseHandlers.has(id)) {
            return this._responseHandlers.get(id);
        }
        else {
            var command = this._waitingRequests.getCommand(id);
            if (command) {
                return this._responseHandlers.get(command);
            }
        }
        return undefined;
    };
    return RpcClient;
}());
var PostMessageRpcClient = /** @class */ (function (_super) {
    __extends(PostMessageRpcClient, _super);
    function PostMessageRpcClient(targetWindow, allowedOrigin) {
        var _this = _super.call(this, allowedOrigin) || this;
        _this._serverCloseCheckInterval = -1;
        _this._target = targetWindow;
        _this._connectionState = 0 /* DISCONNECTED */;
        _this._receiveListener = _this._receive.bind(_this);
        return _this;
    }
    PostMessageRpcClient.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._connectionState === 2 /* CONNECTED */) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this._connect()];
                    case 1:
                        _a.sent();
                        window.addEventListener('message', this._receiveListener);
                        if (this._serverCloseCheckInterval !== -1)
                            return [2 /*return*/];
                        this._serverCloseCheckInterval = window.setInterval(function () { return _this._checkIfServerClosed(); }, 300);
                        return [2 /*return*/];
                }
            });
        });
    };
    PostMessageRpcClient.prototype.call = function (command) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._call({
                        command: command,
                        args: args,
                        id: RandomUtils.generateRandomId(),
                    })];
            });
        });
    };
    PostMessageRpcClient.prototype.close = function () {
        // Clean up old requests and disconnect. Note that until the popup get's closed by the user
        // it's possible to connect again though by calling init.
        this._connectionState = 0 /* DISCONNECTED */;
        window.removeEventListener('message', this._receiveListener);
        window.clearInterval(this._serverCloseCheckInterval);
        this._serverCloseCheckInterval = -1;
        for (var _i = 0, _a = this._responseHandlers; _i < _a.length; _i++) {
            var _b = _a[_i], id = _b[0], reject = _b[1].reject;
            var state = this._waitingRequests.getState(id);
            reject('Connection was closed', typeof id === 'number' ? id : undefined, state);
        }
        this._waitingRequests.clear();
        this._responseHandlers.clear();
        if (this._target && this._target.closed)
            this._target = null;
    };
    PostMessageRpcClient.prototype._receive = function (message) {
        if (message.source !== this._target) {
            // ignore messages originating from another client's target window
            return false;
        }
        return _super.prototype._receive.call(this, message);
    };
    PostMessageRpcClient.prototype._call = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (!this._target || this._target.closed) {
                    throw new Error('Connection was closed.');
                }
                if (this._connectionState !== 2 /* CONNECTED */) {
                    throw new Error('Client is not connected, call init first');
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        // Store the request resolvers
                        _this._responseHandlers.set(request.id, { resolve: resolve, reject: reject });
                        _this._waitingRequests.add(request.id, request.command);
                        console.debug('RpcClient REQUEST', request.command, request.args);
                        _this._target.postMessage(request, _this._allowedOrigin);
                    })];
            });
        });
    };
    PostMessageRpcClient.prototype._connect = function () {
        var _this = this;
        if (this._connectionState === 2 /* CONNECTED */)
            return;
        this._connectionState = 1 /* CONNECTING */;
        return new Promise(function (resolve, reject) {
            var connectedListener = function (message) {
                var source = message.source, origin = message.origin, data = message.data;
                if (source !== _this._target
                    || data.status !== ResponseStatus.OK
                    || data.result !== 'pong'
                    || data.id !== 1
                    || (_this._allowedOrigin !== '*' && origin !== _this._allowedOrigin))
                    return;
                // Debugging printouts
                if (data.result.stack) {
                    var error = new Error(data.result.message);
                    error.stack = data.result.stack;
                    if (data.result.name) {
                        error.name = data.result.name;
                    }
                    console.error(error);
                }
                window.removeEventListener('message', connectedListener);
                _this._connectionState = 2 /* CONNECTED */;
                console.log('RpcClient: Connection established');
                resolve(true);
            };
            window.addEventListener('message', connectedListener);
            /**
             * Send 'ping' command every 100ms, until cancelled
             */
            var tryToConnect = function () {
                if (_this._connectionState === 2 /* CONNECTED */)
                    return;
                if (_this._connectionState === 0 /* DISCONNECTED */
                    || _this._checkIfServerClosed()) {
                    window.removeEventListener('message', connectedListener);
                    reject(new Error('Connection was closed'));
                    return;
                }
                try {
                    _this._target.postMessage({ command: 'ping', id: 1 }, _this._allowedOrigin);
                }
                catch (e) {
                    console.error("postMessage failed: " + e);
                }
                window.setTimeout(tryToConnect, 100);
            };
            window.setTimeout(tryToConnect, 100);
        });
    };
    PostMessageRpcClient.prototype._checkIfServerClosed = function () {
        if (this._target && !this._target.closed)
            return false;
        this.close();
        return true;
    };
    return PostMessageRpcClient;
}(RpcClient));
var RedirectRpcClient = /** @class */ (function (_super) {
    __extends(RedirectRpcClient, _super);
    function RedirectRpcClient(targetURL, allowedOrigin, preserveRequests) {
        if (preserveRequests === void 0) { preserveRequests = true; }
        var _this = _super.call(this, allowedOrigin, /*storeState*/ true) || this;
        _this._target = targetURL;
        _this._preserveRequests = preserveRequests;
        return _this;
    }
    RedirectRpcClient.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var urlResponse, searchParams, storedResponse;
            return __generator(this, function (_a) {
                urlResponse = UrlRpcEncoder.receiveRedirectResponse(window.location);
                if (urlResponse) {
                    this._receive(urlResponse);
                    return [2 /*return*/];
                }
                // If there was no response in the URL it might be a history.back.
                if (this._rejectOnBack())
                    return [2 /*return*/]; // if rejectOnBack did reject do not look for a stored response
                searchParams = new URLSearchParams(window.location.search);
                if (searchParams.has(UrlRpcEncoder.URL_SEARCHPARAM_NAME)) {
                    storedResponse = window.sessionStorage.getItem("response-" + searchParams.get(UrlRpcEncoder.URL_SEARCHPARAM_NAME));
                    if (storedResponse) {
                        this._receive(JSONUtils.parse(storedResponse), false);
                        return [2 /*return*/];
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    /* tslint:disable-next-line:no-empty */
    RedirectRpcClient.prototype.close = function () { };
    RedirectRpcClient.prototype.call = function (returnURL, command, handleHistoryBack) {
        if (handleHistoryBack === void 0) { handleHistoryBack = false; }
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        this.callAndSaveLocalState.apply(this, __spreadArrays([returnURL, null, command, handleHistoryBack], args));
    };
    RedirectRpcClient.prototype.callAndSaveLocalState = function (returnURL, state, command, handleHistoryBack) {
        if (handleHistoryBack === void 0) { handleHistoryBack = false; }
        var args = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            args[_i - 4] = arguments[_i];
        }
        var id = RandomUtils.generateRandomId();
        var url = UrlRpcEncoder.prepareRedirectInvocation(this._target, id, returnURL, command, args);
        this._waitingRequests.add(id, command, state);
        if (handleHistoryBack) {
            /**
             * The rpcBackRejectionId in the history.state is used to detect in the client
             * if a history entry was visited before, which makes it a history.back
             * navigation. The stored ID is then also used to retrieve the correct
             * stored callback and waiting request, to be able to reject it.
             */
            history.replaceState(Object.assign({}, history.state, { rpcBackRejectionId: id }), '');
        }
        console.debug('RpcClient REQUEST', command, args);
        window.location.href = url;
    };
    RedirectRpcClient.prototype._receive = function (response, persistMessage) {
        if (persistMessage === void 0) { persistMessage = true; }
        var responseWasHandled = _super.prototype._receive.call(this, response);
        if (responseWasHandled && persistMessage) {
            window.sessionStorage.setItem("response-" + response.data.id, JSONUtils.stringify(response));
        }
        return responseWasHandled;
    };
    RedirectRpcClient.prototype._rejectOnBack = function () {
        if (!history.state || !history.state.rpcBackRejectionId)
            return false;
        var id = history.state.rpcBackRejectionId;
        // Delete the ID, so the request is not rejected again when the page is refreshed/revisited
        history.replaceState(Object.assign({}, history.state, { rpcBackRejectionId: null }), '');
        var callback = this._getCallback(id);
        var state = this._waitingRequests.getState(id);
        if (callback) {
            if (!this._preserveRequests) {
                this._waitingRequests.remove(id);
                this._responseHandlers.delete(id);
            }
            console.debug('RpcClient BACK');
            var error = new Error('Request aborted');
            callback.reject(error, id, state);
            return true;
        }
        return false;
    };
    return RedirectRpcClient;
}(RpcClient));
var RequestBehavior = /** @class */ (function () {
    function RequestBehavior(type) {
        this._type = type;
    }
    RequestBehavior.getAllowedOrigin = function (endpoint) {
        var url = new URL(endpoint);
        return url.origin;
    };
    RequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Not implemented');
            });
        });
    };
    return RequestBehavior;
}());
var BehaviorType;
(function (BehaviorType) {
    BehaviorType[BehaviorType["REDIRECT"] = 0] = "REDIRECT";
    BehaviorType[BehaviorType["POPUP"] = 1] = "POPUP";
    BehaviorType[BehaviorType["IFRAME"] = 2] = "IFRAME";
})(BehaviorType || (BehaviorType = {}));
var RedirectRequestBehavior = /** @class */ (function (_super) {
    __extends(RedirectRequestBehavior, _super);
    function RedirectRequestBehavior(returnUrl, localState) {
        var _this = _super.call(this, BehaviorType.REDIRECT) || this;
        var location = window.location;
        _this._returnUrl = returnUrl || "" + location.origin + location.pathname;
        _this._localState = localState || {};
        // Reject local state with reserved property.
        if (typeof _this._localState.__command !== 'undefined') {
            throw new Error('Invalid localState: Property \'__command\' is reserved');
        }
        return _this;
    }
    RedirectRequestBehavior.withLocalState = function (localState) {
        return new RedirectRequestBehavior(undefined, localState);
    };
    RedirectRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, client, state;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        client = new RedirectRpcClient(endpoint, origin);
                        return [4 /*yield*/, client.init()];
                    case 1:
                        _a.sent();
                        state = Object.assign({}, this._localState, { __command: command });
                        client.callAndSaveLocalState.apply(client, __spreadArrays([this._returnUrl, state, command, true], args));
                        return [2 /*return*/];
                }
            });
        });
    };
    return RedirectRequestBehavior;
}(RequestBehavior));
var PopupRequestBehavior = /** @class */ (function (_super) {
    __extends(PopupRequestBehavior, _super);
    function PopupRequestBehavior(options) {
        if (options === void 0) { options = PopupRequestBehavior.DEFAULT_OPTIONS; }
        var _this = _super.call(this, BehaviorType.POPUP) || this;
        _this._options = options;
        return _this;
    }
    PopupRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, popup, client, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        popup = this.createPopup(endpoint);
                        client = new PostMessageRpcClient(popup, origin);
                        return [4 /*yield*/, client.init()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, 5, 6]);
                        return [4 /*yield*/, client.call.apply(client, __spreadArrays([command], args))];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        e_1 = _a.sent();
                        throw e_1;
                    case 5:
                        client.close();
                        popup.close();
                        return [7 /*endfinally*/];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    PopupRequestBehavior.prototype.createPopup = function (url) {
        var popup = window.open(url, 'NimiqAccounts', this._options);
        if (!popup) {
            throw new Error('Failed to open popup');
        }
        return popup;
    };
    return PopupRequestBehavior;
}(RequestBehavior));
PopupRequestBehavior.DEFAULT_OPTIONS = '';
var IFrameRequestBehavior = /** @class */ (function (_super) {
    __extends(IFrameRequestBehavior, _super);
    function IFrameRequestBehavior() {
        var _this = _super.call(this, BehaviorType.IFRAME) || this;
        _this._iframe = null;
        _this._client = null;
        return _this;
    }
    IFrameRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (this._iframe && this._iframe.src !== "" + endpoint + IFrameRequestBehavior.IFRAME_PATH_SUFFIX) {
                            throw new Error('Hub iframe is already opened with another endpoint');
                        }
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        if (!!this._iframe) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.createIFrame(endpoint)];
                    case 1:
                        _a._iframe = _c.sent();
                        _c.label = 2;
                    case 2:
                        if (!this._iframe.contentWindow) {
                            throw new Error("IFrame contentWindow is " + typeof this._iframe.contentWindow);
                        }
                        if (!!this._client) return [3 /*break*/, 4];
                        this._client = new PostMessageRpcClient(this._iframe.contentWindow, origin);
                        return [4 /*yield*/, this._client.init()];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [4 /*yield*/, (_b = this._client).call.apply(_b, __spreadArrays([command], args))];
                    case 5: return [2 /*return*/, _c.sent()];
                }
            });
        });
    };
    IFrameRequestBehavior.prototype.createIFrame = function (endpoint) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var $iframe = document.createElement('iframe');
                        $iframe.name = 'NimiqAccountsIFrame';
                        $iframe.style.display = 'none';
                        document.body.appendChild($iframe);
                        $iframe.src = "" + endpoint + IFrameRequestBehavior.IFRAME_PATH_SUFFIX;
                        $iframe.onload = function () { return resolve($iframe); };
                        $iframe.onerror = reject;
                    })];
            });
        });
    };
    return IFrameRequestBehavior;
}(RequestBehavior));
IFrameRequestBehavior.IFRAME_PATH_SUFFIX = '/iframe.html';
var RequestType;
(function (RequestType) {
    RequestType["LIST"] = "list";
    RequestType["MIGRATE"] = "migrate";
    RequestType["CHECKOUT"] = "checkout";
    RequestType["SIGN_MESSAGE"] = "sign-message";
    RequestType["SIGN_TRANSACTION"] = "sign-transaction";
    RequestType["ONBOARD"] = "onboard";
    RequestType["SIGNUP"] = "signup";
    RequestType["LOGIN"] = "login";
    RequestType["EXPORT"] = "export";
    RequestType["CHANGE_PASSWORD"] = "change-password";
    RequestType["LOGOUT"] = "logout";
    RequestType["ADD_ADDRESS"] = "add-address";
    RequestType["RENAME"] = "rename";
    RequestType["CHOOSE_ADDRESS"] = "choose-address";
})(RequestType || (RequestType = {}));
var HubApi = /** @class */ (function () {
    function HubApi(endpoint, defaultBehavior) {
        if (endpoint === void 0) { endpoint = HubApi.DEFAULT_ENDPOINT; }
        this._endpoint = endpoint;
        this._defaultBehavior = defaultBehavior || new PopupRequestBehavior("left=" + (window.innerWidth / 2 - 400) + ",top=75,width=800,height=850,location=yes,dependent=yes");
        this._iframeBehavior = new IFrameRequestBehavior();
        // Check for RPC results in the URL
        this._redirectClient = new RedirectRpcClient('', RequestBehavior.getAllowedOrigin(this._endpoint));
    }
    Object.defineProperty(HubApi, "DEFAULT_ENDPOINT", {
        get: function () {
            var originArray = location.origin.split('.');
            originArray.shift();
            var tld = originArray.join('.');
            switch (tld) {
                case 'nimiq.com':
                    return 'https://hub.nimiq.com';
                case 'nimiq-testnet.com':
                    return 'https://hub.nimiq-testnet.com';
                default:
                    return 'http://localhost:8080';
            }
        },
        enumerable: true,
        configurable: true
    });
    HubApi.prototype.checkRedirectResponse = function () {
        return this._redirectClient.init();
    };
    HubApi.prototype.on = function (command, resolve, reject) {
        this._redirectClient.onResponse(command, 
        // State is always an object containing at least the __command property
        function (result, rpcId, state) { return resolve(result, state); }, function (error, rpcId, state) {
            if (!reject)
                return;
            reject(error, state);
        });
    };
    /**
     * Public API
     */
    HubApi.prototype.checkout = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHECKOUT, [request]);
    };
    HubApi.prototype.chooseAddress = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHOOSE_ADDRESS, [request]);
    };
    HubApi.prototype.signTransaction = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGN_TRANSACTION, [request]);
    };
    HubApi.prototype.signMessage = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGN_MESSAGE, [request]);
    };
    /**
     * Account Management
     *
     * Only accessible from Nimiq domains.
     */
    HubApi.prototype.onboard = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.ONBOARD, [request]);
    };
    HubApi.prototype.signup = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGNUP, [request]);
    };
    HubApi.prototype.login = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.LOGIN, [request]);
    };
    HubApi.prototype.logout = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.LOGOUT, [request]);
    };
    HubApi.prototype.export = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.EXPORT, [request]);
    };
    HubApi.prototype.changePassword = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHANGE_PASSWORD, [request]);
    };
    HubApi.prototype.addAddress = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.ADD_ADDRESS, [request]);
    };
    HubApi.prototype.rename = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.RENAME, [request]);
    };
    HubApi.prototype.migrate = function (requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.MIGRATE, [{ appName: 'Account list' }]);
    };
    /**
     * Only accessible in iframe from Nimiq domains.
     */
    HubApi.prototype.list = function (requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._iframeBehavior; }
        return this._request(requestBehavior, RequestType.LIST, []);
    };
    // END API
    /* PRIVATE METHODS */
    HubApi.prototype._request = function (behavior, command, args) {
        return behavior.request(this._endpoint, command, args);
    };
    return HubApi;
}());
HubApi.RequestType = RequestType;
HubApi.RedirectRequestBehavior = RedirectRequestBehavior;
HubApi.MSG_PREFIX = '\x16Nimiq Signed Message:\n';
var HubUrl = {
    main: 'https://hub.nimiq.com',
    test: 'https://hub.nimiq-testnet.com',
};
var Hexagon = function (props) { return (h("svg", { viewBox: "0 0 27 24", class: props.class }, h("path", { d: "M26.6991 10.875L21.0741 1.125C20.6691 0.4275 19.9266 0 19.1241 0H7.87414C7.07164 0 6.32914 0.4275 5.92789 1.125L0.302891 10.875C-0.0983594 11.5725 -0.0983594 12.4275 0.302891 13.125L5.92789 22.875C6.32914 23.5725 7.07164 24 7.87414 24H19.1241C19.9266 24 20.6691 23.5725 21.0704 22.875L26.6954 13.125C27.1004 12.4275 27.1004 11.5725 26.6991 10.875Z", fill: "currentColor" }))); };
var Close = function (props) { return (h("svg", { viewBox: "0 0 24 24", class: props.class }, h("path", { "fill-rule": "evenodd", "clip-rule": "evenodd", d: "M3.528 3.52c4.683-4.684 12.275-4.686 16.96-.005 4.678 4.69 4.678 12.28 0 16.97-4.685 4.68-12.277 4.678-16.96-.005-4.682-4.684-4.682-12.276 0-16.96zm13.145 13.133a1 1 0 0 0 .036-1.374l-3.11-3.11a.25.25 0 0 1 0-.352l3.11-3.11a1 1 0 1 0-1.414-1.415l-3.11 3.11a.25.25 0 0 1-.354 0l-3.11-3.11a1 1 0 0 0-1.41 1.415l3.11 3.11a.249.249 0 0 1 0 .353l-3.11 3.109a1 1 0 0 0 0 1.415c.396.38 1.021.38 1.416 0l3.109-3.11a.252.252 0 0 1 .354 0l3.11 3.11a1 1 0 0 0 1.373-.041z", fill: "currentColor" }))); };
var Checkout = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.inProgress = false;
        /**
         * The theme of the button. Use light when using against dark background.
         */
        this.theme = 'neutral';
        /**
         * The network you want to use. Can be 'main' or 'test'.
         */
        this.network = 'main';
        /**
         * The text to display on the button. Default: "Pay with NIM"
         */
        this.text = 'Pay with NIM';
        this.nimCheckoutSuccess = createEvent(this, "nimCheckoutSuccess", 7);
        this.nimCheckoutError = createEvent(this, "nimCheckoutError", 7);
    }
    class_1.prototype.checkout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, hubApi, transaction, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.inProgress = true;
                        options = {
                            appName: this.app,
                            recipient: this.recipient,
                            value: this.value,
                        };
                        if (this.logoUrl) {
                            options.shopLogoUrl = this.logoUrl;
                        }
                        if (this.fee) {
                            options.fee = this.fee;
                        }
                        if (this.data) {
                            options.extraData = this.data;
                        }
                        hubApi = new HubApi(HubUrl[this.network]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, hubApi.checkout(options)];
                    case 2:
                        transaction = _a.sent();
                        this.nimCheckoutSuccess.emit(transaction);
                        this.inProgress = false;
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        this.nimCheckoutError.emit(error_1);
                        this.inProgress = false;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.render = function () {
        var _this = this;
        return (h("button", { class: 'nim-theme-' + this.theme, disabled: this.inProgress, type: "button", onClick: function (_) { return _this.checkout(); } }, h(Hexagon, { class: "nim-icon nim-logo" }), h("div", null, this.inProgress ? h("span", null, "In progress...") : h("span", null, this.text))));
    };
    Object.defineProperty(class_1, "style", {
        get: function () { return ":host{display:inline-block;--nimiq-blue:#1f2348;--nimiq-light-blue:#0582ca;--nimiq-gold:#e9b213;--nimiq-green:#21bca5;--nimiq-orange:#fc8702;--nimiq-red:#d94432;--nimiq-gray:#e2e8f0;--nimiq-light-gray:#edf2f7;--nimiq-blue-darkened:#151833;--nimiq-light-blue-darkened:#0071c3;--nimiq-gold-darkened:#e5a212;--nimiq-green-darkened:#20b29e;--nimiq-orange-darkened:#fc7500;--nimiq-red-darkened:#d13030;--nimiq-blue-bg:radial-gradient(ellipse at bottom right,#260133,var(--nimiq-blue));--nimiq-light-blue-bg:radial-gradient(ellipse at bottom right,#265dd7,var(--nimiq-light-blue));--nimiq-gold-bg:radial-gradient(ellipse at bottom right,#ec991c,var(--nimiq-gold));--nimiq-green-bg:radial-gradient(ellipse at bottom right,#41a38e,var(--nimiq-green));--nimiq-orange-bg:radial-gradient(ellipse at bottom right,#fd6216,var(--nimiq-orange));--nimiq-red-bg:radial-gradient(ellipse at bottom right,#cc3047,var(--nimiq-red));--nimiq-blue-bg-darkened:radial-gradient(ellipse at bottom right,#180021,var(--nimiq-blue-darkened));--nimiq-light-blue-bg-darkened:radial-gradient(ellipse at bottom right,#2355c4,var(--nimiq-light-blue-darkened));--nimiq-gold-bg-darkened:radial-gradient(ellipse at bottom right,#e58a1b,var(--nimiq-gold-darkened));--nimiq-green-bg-darkened:radial-gradient(ellipse at bottom right,#3d9988,var(--nimiq-green-darkened));--nimiq-orange-bg-darkened:radial-gradient(ellipse at bottom right,#ea5200,var(--nimiq-orange-darkened));--nimiq-red-bg-darkened:radial-gradient(ellipse at bottom right,#bf2d46,var(--nimiq-red-darkened))}button{border-radius:100px;border:0 none;padding:12px 20px;margin:0;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;font-size:16px;font-family:-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,Oxygen,Ubuntu,Cantarell,Open Sans,Helvetica Neue,sans-serif;cursor:pointer;position:relative;-webkit-box-shadow:none;box-shadow:none;-webkit-transition:all .3s cubic-bezier(.25,0,0,1);transition:all .3s cubic-bezier(.25,0,0,1)}button:after{content:\"\";position:absolute;left:-5px;top:-5px;right:-5px;bottom:-5px;border:2px solid rgba(5,130,202,.5);border-radius:500px;opacity:0}button:focus{outline:none}button:focus:not([disabled]):after{opacity:1}button:hover{-webkit-transform:translateY(-2px);transform:translateY(-2px);-webkit-box-shadow:0 .6rem 1rem rgba(0,0,0,.1);box-shadow:0 .6rem 1rem rgba(0,0,0,.1)}button[disabled]{background:var(--nimiq-gray)!important;-webkit-box-shadow:none!important;box-shadow:none!important;-webkit-transform:none!important;transform:none!important;color:var(--nimiq-blue)!important;cursor:not-allowed;opacity:.4}button[disabled]>.nim-icon{color:var(--nimiq-blue)}.nim-logo{width:24px;height:24px;margin-right:12px}.nim-theme-neutral{color:var(--nimiq-blue);background-color:var(--nimiq-light-gray)}.nim-theme-neutral:hover{background-color:var(--nimiq-gray);-webkit-box-shadow:none;box-shadow:none}.nim-theme-neutral>.nim-icon{color:#e9b213}.nim-theme-blue{color:#fff;background-image:var(--nimiq-blue-bg)}.nim-theme-blue:hover{color:#fff;background-image:var(--nimiq-blue-bg-darkened)}.nim-theme-blue>.nim-icon{color:var(--nimiq-gold)}.nim-theme-gold{color:#fff;background-image:var(--nimiq-gold-bg)}.nim-theme-gold:hover{color:#fff;background-image:var(--nimiq-gold-bg-darkened)}.nim-theme-gold>.nim-icon{color:#fff}.nim-theme-light-blue{color:#fff;background-image:var(--nimiq-light-blue-bg)}.nim-theme-light-blue:hover{color:#fff;background-image:var(--nimiq-light-blue-bg-darkened)}.nim-theme-light-blue>.nim-icon{color:#fff}.nim-theme-green{color:#fff;background-image:var(--nimiq-green-bg)}.nim-theme-green:hover{color:#fff;background-image:var(--nimiq-green-bg-darkened)}.nim-theme-green>.nim-icon{color:#fff}.nim-theme-orange{color:#fff;background-image:var(--nimiq-orange-bg)}.nim-theme-orange:hover{color:#fff;background-image:var(--nimiq-orange-bg-darkened)}.nim-theme-orange>.nim-icon{color:#fff}.nim-theme-red{color:#fff;background-image:var(--nimiq-red-bg)}.nim-theme-red:hover{color:#fff;background-image:var(--nimiq-red-bg-darkened)}.nim-theme-red>.nim-icon{color:#fff}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
var Iqons = /** @class */ (function () {
    function Iqons() {
    }
    Iqons.svg = function (t) {
        return __awaiter(this, void 0, void 0, function () { var e; return __generator(this, function (_a) {
            e = makeHash(t);
            return [2 /*return*/, this._svgTemplate(e[0], e[2], e[3] + e[4], e[5] + e[6], e[7] + e[8], e[9] + e[10], e[11])];
        }); });
    };
    Iqons.render = function (t, e) {
        return __awaiter(this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = e;
                    return [4 /*yield*/, this.svg(t)];
                case 1:
                    _a.innerHTML = _b.sent();
                    return [2 /*return*/];
            }
        }); });
    };
    Iqons.toDataUrl = function (t) {
        return __awaiter(this, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = "data:image/svg+xml;base64,";
                    _b = this._btoa;
                    return [4 /*yield*/, this.svg(t, !0)];
                case 1: return [2 /*return*/, _a + _b.apply(this, [_c.sent()])];
            }
        }); });
    };
    Iqons.placeholder = function (t, e) {
        if (t === void 0) { t = "#bbb"; }
        if (e === void 0) { e = 1; }
        return "<svg viewBox=\"0 0 160 160\" width=\"160\" height=\"160\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/2000/xlink\" >\n<path fill=\"none\" stroke=\"" + t + "\" stroke-width=\"" + 2 * e + "\" transform=\"translate(0, 8) scale(0.5)\" d=\"M251.6 17.34l63.53 110.03c5.72 9.9 5.72 22.1 0 32L251.6 269.4c-5.7 9.9-16.27 16-27.7 16H96.83c-11.43 0-22-6.1-27.7-16L5.6 159.37c-5.7-9.9-5.7-22.1 0-32L69.14 17.34c5.72-9.9 16.28-16 27.7-16H223.9c11.43 0 22 6.1 27.7 16z\"/>\n<g transform=\"scale(0.9) translate(9, 8)\">\n<circle cx=\"80\" cy=\"80\" r=\"40\" fill=\"none\" stroke=\"" + t + "\" stroke-width=\"" + e + "\" opacity=\".9\"></circle>\n<g opacity=\".1\" fill=\"#010101\"><path d=\"M119.21,80a39.46,39.46,0,0,1-67.13,28.13c10.36,2.33,36,3,49.82-14.28,10.39-12.47,8.31-33.23,4.16-43.26A39.35,39.35,0,0,1,119.21,80Z\"/></g>\n</g></svg>";
    };
    Iqons.renderPlaceholder = function (t, e, s) { t.innerHTML = this.placeholder(e, s); };
    Iqons.placeholderToDataUrl = function (t, e) { return "data:image/svg+xml;base64," + this._btoa(this.placeholder(t, e)); };
    Iqons.image = function (t) {
        return __awaiter(this, void 0, void 0, function () { var e, s; return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, this.toDataUrl(t)];
                case 1:
                    e = _a.sent();
                    return [4 /*yield*/, this._loadImage(e)];
                case 2:
                    s = _a.sent();
                    return [2 /*return*/, (s.style.width = "100%", s.style.height = "100%", s)];
            }
        }); });
    };
    Iqons._svgTemplate = function (t, e, s, a, n, i, r) {
        return __awaiter(this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = this._$svg;
                    return [4 /*yield*/, this._$iqons(t, e, s, a, n, i, r)];
                case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
            }
        }); });
    };
    Iqons._$iqons = function (t, e, s, a, n, i, r) {
        return __awaiter(this, void 0, void 0, function () { var o, _a, _b, _c, _d; return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    o = hashToRGB(t, e, r);
                    t = o.main, e = o.background;
                    _a = "<g color=\"" + t + "\" fill=\"" + (r = o.accent) + "\">\n<rect fill=\"" + e + "\" x=\"0\" y=\"0\" width=\"160\" height=\"160\"></rect>\n<circle cx=\"80\" cy=\"80\" r=\"40\" fill=\"" + t + "\"></circle>\n<g opacity=\".1\" fill=\"#010101\"><path d=\"M119.21,80a39.46,39.46,0,0,1-67.13,28.13c10.36,2.33,36,3,49.82-14.28,10.39-12.47,8.31-33.23,4.16-43.26A39.35,39.35,0,0,1,119.21,80Z\"/></g>\n";
                    return [4 /*yield*/, this._generatePart("top", a)];
                case 1:
                    _b = _a + (_e.sent()) + "\n";
                    return [4 /*yield*/, this._generatePart("side", n)];
                case 2:
                    _c = _b + (_e.sent()) + "\n";
                    return [4 /*yield*/, this._generatePart("face", s)];
                case 3:
                    _d = _c + (_e.sent()) + "\n";
                    return [4 /*yield*/, this._generatePart("bottom", i)];
                case 4: return [2 /*return*/, _d + (_e.sent()) + "\n</g>"];
            }
        }); });
    };
    Iqons._$svg = function (t) { var e = this._getRandomId(); return "<svg viewBox=\"0 0 160 160\" width=\"160\" height=\"160\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/2000/xlink\" >\n<defs><clipPath id=\"hexagon-clip-" + e + "\">\n<path d=\"M251.6 17.34l63.53 110.03c5.72 9.9 5.72 22.1 0 32L251.6 269.4c-5.7 9.9-16.27 16-27.7 16H96.83c-11.43 0-22-6.1-27.7-16L5.6 159.37c-5.7-9.9-5.7-22.1 0-32L69.14 17.34c5.72-9.9 16.28-16 27.7-16H223.9c11.43 0 22 6.1 27.7 16z\" transform=\"scale(0.5) translate(0, 16)\"/>\n</clipPath></defs>\n<g clip-path=\"url(#hexagon-clip-" + e + ")\">\n" + t + "\n</g></svg>"; };
    Iqons._generatePart = function (t, e) {
        return __awaiter(this, void 0, void 0, function () { var s, a, n; return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, this._getAssets()];
                case 1:
                    s = _a.sent(), a = t + "_" + this._assetIndex(e, t), n = s.getElementById(a);
                    return [2 /*return*/, n ? n.innerHTML : ""];
            }
        }); });
    };
    Iqons._loadImage = function (t) { return new Promise(function (e, s) { var a = document.createElement("img"); a.addEventListener("load", function (t) { return e(a); }, { once: !0 }), a.src = t; }); };
    Iqons._getAssets = function () {
        return __awaiter(this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, this._assetsPromise || (this._assetsPromise = new Promise(function (t) {
                    return __awaiter(this, void 0, void 0, function () { var e, _a; return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                if (!("undefined" != typeof IqonsAssets)) return [3 /*break*/, 1];
                                _a = IqonsAssets;
                                return [3 /*break*/, 3];
                            case 1: return [4 /*yield*/, fetch(self.NIMIQ_IQONS_SVG_PATH || Iqons.svgPath).then(function (t) { return t.text(); })];
                            case 2:
                                _a = _b.sent();
                                _b.label = 3;
                            case 3:
                                e = _a, "undefined" != typeof module && module.exports && (global.DOMParser = require("dom-parser")), t((new DOMParser).parseFromString(e, "image/svg+xml"));
                                return [2 /*return*/];
                        }
                    }); });
                }))];
        }); });
    };
    Iqons._btoa = function (t) { return "undefined" != typeof module && module.exports ? new Buffer(t).toString("base64") : btoa(t); };
    Iqons._assetIndex = function (t, e) { return (t = Number(t) % Iqons.ASSET_COUNTS[e] + 1) < 10 && (t = "0" + t), t; };
    Iqons._getRandomId = function () { return Math.floor(256 * Math.random()); };
    return Iqons;
}());
// @asset(/node_modules/@nimiq/iqons/dist/iqons.min.svg);
Iqons.svgPath = "/node_modules/@nimiq/iqons/dist/iqons.min.svg", Iqons.ASSET_COUNTS = { top: 21, side: 21, face: 21, bottom: 21 };
function makeHash(t) { var r = ("" + t.split("").map(function (t) { return Number(t.charCodeAt(0)) + 3; }).reduce(function (t, r) { return t * (1 - t) * __chaosHash(r); }, .5)).split("").reduce(function (t, r) { return r + t; }, ""); return _padEnd(r.replace(".", r[5]).substr(4, 17), 13, r[5]); }
function __chaosHash(t) { var r = 1 / t; for (var t_1 = 0; t_1 < 100; t_1++)
    r = (1 - r) * r * 3.569956786876; return r; }
function _padEnd(t, r, e) { if (String.prototype.padEnd)
    return t.padEnd(r, e); for (; t.length < r;)
    t += e; return t.substring(0, Math.max(t.length, r)); }
function hashToRGB(o, n, r) { return indicesToRGB(hashToIndices(o, n, r)); }
function hashToIndices(o, n, r) { for (o = parseInt(o, 10), n = parseInt(n, 10), r = parseInt(r, 10), o === n && ++o > 9 && (o = 0); r === o || r === n;)
    ++r > 9 && (r = 0); return { main: o, background: n, accent: r }; }
function indicesToRGB(o) { return { main: colors[o.main], background: backgroundColors[o.background], accent: colors[o.accent] }; }
var colors = ["#FC8702", "#D94432", "#E9B213", "#1A5493", "#0582CA", "#5961A8", "#21BCA5", "#FA7268", "#88B04B", "#795548"];
var backgroundColors = ["#FC8702", "#D94432", "#E9B213", "#1F2348", "#0582CA", "#5F4B8B", "#21BCA5", "#FA7268", "#88B04B", "#795548"];
var Status;
(function (Status) {
    Status[Status["Idle"] = 0] = "Idle";
    Status[Status["Progress"] = 1] = "Progress";
    Status[Status["Success"] = 2] = "Success";
    Status[Status["Error"] = 3] = "Error";
})(Status || (Status = {}));
var Donate = /** @class */ (function () {
    function class_2(hostRef) {
        registerInstance(this, hostRef);
        this.status = Status.Idle;
        this.isOpen = false;
        this.addressChunks = [];
        /**
         * The theme of the button. Use light when using against dark background.
         */
        this.theme = 'neutral';
        /**
         * The network you want to use. Can be 'main' or 'test'.
         */
        this.network = 'main';
        /**
         * The text to display on the button. Default: "Donate NIM"
         */
        this.text = 'Donate NIM';
        /**
         * The text to display once payment is done. Default: "Thank you for the donation!"
         */
        this.thankyou = 'Thank you for the donation!';
    }
    class_2.prototype.onRecipientChanged = function () {
        this.breakAddressIntoChunks();
        this.generateIdenticon();
    };
    class_2.prototype.componentWillLoad = function () {
        Iqons.svgPath = getAssetPath('./identicons/iqons.min.svg');
        this.breakAddressIntoChunks();
        this.generateIdenticon();
    };
    class_2.prototype.breakAddressIntoChunks = function () {
        var addressWithoutSpaces = this.recipient.replace(/\s/g, '');
        this.addressChunks = addressWithoutSpaces.match(/.{1,4}/g);
    };
    class_2.prototype.generateIdenticon = function () {
        var _this = this;
        Iqons.toDataUrl(this.recipient).then(function (identicon) {
            _this.identicon = identicon;
        });
    };
    class_2.prototype.open = function () {
        this.isOpen = true;
    };
    class_2.prototype.close = function () {
        this.isOpen = false;
    };
    class_2.prototype.donate = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var options, hubApi, error_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        event.preventDefault();
                        this.status = Status.Progress;
                        options = {
                            appName: this.text,
                            recipient: this.recipient,
                            value: this.amount * 100000,
                        };
                        if (this.logoUrl) {
                            options.shopLogoUrl = this.logoUrl;
                        }
                        if (this.fee) {
                            options.fee = this.fee;
                        }
                        if (this.message) {
                            options.extraData = this.message.trim();
                        }
                        hubApi = new HubApi(HubUrl[this.network]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, hubApi.checkout(options)];
                    case 2:
                        _a.sent();
                        this.status = Status.Success;
                        setTimeout(function () {
                            _this.status = Status.Idle;
                            _this.close();
                        }, 2000);
                        return [3 /*break*/, 4];
                    case 3:
                        error_2 = _a.sent();
                        this.status = Status.Error;
                        setTimeout(function () {
                            _this.status = Status.Idle;
                        }, 2000);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.updateAmount = function (event) {
        this.amount = parseFloat(event.target.value);
    };
    class_2.prototype.updateMessage = function (event) {
        this.message = event.target.value;
    };
    class_2.prototype.canConfirm = function () {
        return this.amount > 0;
    };
    class_2.prototype.render = function () {
        var _this = this;
        return (h("div", { class: "donate" }, h("button", { class: 'nim-button nim-theme-' + this.theme, disabled: this.status === Status.Progress, type: "button", onClick: function (_) { return _this.open(); } }, h(Hexagon, { class: "nim-icon nim-logo" }), h("div", null, h("span", null, this.text))), h("div", { class: { overlay: true, 'is-open': this.isOpen } }, h("div", { class: "dialog" }, h("button", { onClick: function (_) { return _this.close(); }, type: "button", class: "close" }, h(Close, { class: "nim-icon" })), h("form", { onSubmit: function (e) { return _this.donate(e); } }, h("h2", null, "Donate"), h("div", { class: "recipient" }, h("div", { class: "identicon" }, h("img", { src: this.identicon })), h("div", { class: "address" }, this.addressChunks.map(function (chunk) { return (h("span", { class: "chunk" }, chunk)); }))), h("div", { class: "amount" }, h("input", { onInput: function (e) { return _this.updateAmount(e); }, type: "text", placeholder: "0.00" }), h("span", { class: "ticker" }, "NIM")), h("div", { class: "message" }, h("input", { onInput: function (e) { return _this.updateMessage(e); }, type: "text", maxLength: 64, placeholder: "Add a message..." })), h("div", { class: "confirm" }, h("button", { disabled: !this.canConfirm(), class: "nim-button nim-theme-light-blue", type: "submit" }, "Confirm"))), h("div", { class: {
                flash: true,
                show: this.status !== Status.Idle,
            } }, h("p", null, "Transaction in progress...")), h("div", { class: {
                'flash success': true,
                show: this.status === Status.Success,
            } }, h("p", null, this.thankyou)), h("div", { class: {
                'flash error': true,
                show: this.status === Status.Error,
            } }, h("p", null, "Transaction failed. Please try again."))))));
    };
    Object.defineProperty(class_2, "assetsDirs", {
        get: function () { return ["identicons"]; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_2, "watchers", {
        get: function () {
            return {
                "recipient": ["onRecipientChanged"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_2, "style", {
        get: function () { return ":host{display:inline-block;--nimiq-blue:#1f2348;--nimiq-light-blue:#0582ca;--nimiq-gold:#e9b213;--nimiq-green:#21bca5;--nimiq-orange:#fc8702;--nimiq-red:#d94432;--nimiq-gray:#e2e8f0;--nimiq-light-gray:#edf2f7;--nimiq-blue-darkened:#151833;--nimiq-light-blue-darkened:#0071c3;--nimiq-gold-darkened:#e5a212;--nimiq-green-darkened:#20b29e;--nimiq-orange-darkened:#fc7500;--nimiq-red-darkened:#d13030;--nimiq-blue-bg:radial-gradient(ellipse at bottom right,#260133,var(--nimiq-blue));--nimiq-light-blue-bg:radial-gradient(ellipse at bottom right,#265dd7,var(--nimiq-light-blue));--nimiq-gold-bg:radial-gradient(ellipse at bottom right,#ec991c,var(--nimiq-gold));--nimiq-green-bg:radial-gradient(ellipse at bottom right,#41a38e,var(--nimiq-green));--nimiq-orange-bg:radial-gradient(ellipse at bottom right,#fd6216,var(--nimiq-orange));--nimiq-red-bg:radial-gradient(ellipse at bottom right,#cc3047,var(--nimiq-red));--nimiq-blue-bg-darkened:radial-gradient(ellipse at bottom right,#180021,var(--nimiq-blue-darkened));--nimiq-light-blue-bg-darkened:radial-gradient(ellipse at bottom right,#2355c4,var(--nimiq-light-blue-darkened));--nimiq-gold-bg-darkened:radial-gradient(ellipse at bottom right,#e58a1b,var(--nimiq-gold-darkened));--nimiq-green-bg-darkened:radial-gradient(ellipse at bottom right,#3d9988,var(--nimiq-green-darkened));--nimiq-orange-bg-darkened:radial-gradient(ellipse at bottom right,#ea5200,var(--nimiq-orange-darkened));--nimiq-red-bg-darkened:radial-gradient(ellipse at bottom right,#bf2d46,var(--nimiq-red-darkened))}.donate{font-family:-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,Oxygen,Ubuntu,Cantarell,Open Sans,Helvetica Neue,sans-serif}button{font-size:16px;border:0 none;background:none;cursor:pointer}.nim-button{border-radius:100px;padding:12px 20px;margin:0;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;position:relative;-webkit-box-shadow:none;box-shadow:none;-webkit-transition:all .3s cubic-bezier(.25,0,0,1);transition:all .3s cubic-bezier(.25,0,0,1)}button:after{content:\"\";position:absolute;left:-5px;top:-5px;right:-5px;bottom:-5px;border:2px solid rgba(5,130,202,.5);border-radius:500px;opacity:0}button:focus{outline:none}button:focus:not([disabled]):after{opacity:1}.nim-button:hover{-webkit-transform:translateY(-2px);transform:translateY(-2px);-webkit-box-shadow:0 .6rem 1rem rgba(0,0,0,.1);box-shadow:0 .6rem 1rem rgba(0,0,0,.1)}.nim-button[disabled]{background:var(--nimiq-gray)!important;-webkit-box-shadow:none!important;box-shadow:none!important;-webkit-transform:none!important;transform:none!important;color:var(--nimiq-blue)!important;cursor:not-allowed;opacity:.4}.nim-button[disabled]>.nim-icon{color:var(--nimiq-blue)}.nim-logo{width:24px;height:24px;margin-right:12px}.nim-theme-neutral{color:var(--nimiq-blue);background-color:var(--nimiq-light-gray)}.nim-theme-neutral:hover{background-color:var(--nimiq-gray);-webkit-box-shadow:none;box-shadow:none}.nim-theme-neutral>.nim-icon{color:#e9b213}.nim-theme-blue{color:#fff;background-image:var(--nimiq-blue-bg)}.nim-theme-blue:hover{color:#fff;background-image:var(--nimiq-blue-bg-darkened)}.nim-theme-blue>.nim-icon{color:var(--nimiq-gold)}.nim-theme-gold{color:#fff;background-image:var(--nimiq-gold-bg)}.nim-theme-gold:hover{color:#fff;background-image:var(--nimiq-gold-bg-darkened)}.nim-theme-gold>.nim-icon{color:#fff}.nim-theme-light-blue{color:#fff;background-image:var(--nimiq-light-blue-bg)}.nim-theme-light-blue:hover{color:#fff;background-image:var(--nimiq-light-blue-bg-darkened)}.nim-theme-light-blue>.nim-icon{color:#fff}.nim-theme-green{color:#fff;background-image:var(--nimiq-green-bg)}.nim-theme-green:hover{color:#fff;background-image:var(--nimiq-green-bg-darkened)}.nim-theme-green>.nim-icon{color:#fff}.nim-theme-orange{color:#fff;background-image:var(--nimiq-orange-bg)}.nim-theme-orange:hover{color:#fff;background-image:var(--nimiq-orange-bg-darkened)}.nim-theme-orange>.nim-icon{color:#fff}.nim-theme-red{color:#fff;background-image:var(--nimiq-red-bg)}.nim-theme-red:hover{color:#fff;background-image:var(--nimiq-red-bg-darkened)}.nim-theme-red>.nim-icon{color:#fff}.overlay{width:0;height:0;overflow:hidden;display:-ms-flexbox;display:flex;position:fixed;top:0;right:0;bottom:0;left:0;background-color:rgba(31,35,72,.8);-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;z-index:-1}.overlay.is-open{width:100%;height:100%;z-index:500}.dialog{position:relative;max-width:320px;width:90%;color:var(--nimiq-blue);background-color:#fff;-webkit-box-shadow:0 .5rem 3.5rem rgba(0,0,0,.12);box-shadow:0 .5rem 3.5rem rgba(0,0,0,.12);border-radius:8px;-webkit-transform:translateY(24px);transform:translateY(24px);opacity:0;-webkit-transition:opacity .4s cubic-bezier(.25,0,0,1),-webkit-transform .4s cubic-bezier(.25,0,0,1);transition:opacity .4s cubic-bezier(.25,0,0,1),-webkit-transform .4s cubic-bezier(.25,0,0,1);transition:transform .4s cubic-bezier(.25,0,0,1),opacity .4s cubic-bezier(.25,0,0,1);transition:transform .4s cubic-bezier(.25,0,0,1),opacity .4s cubic-bezier(.25,0,0,1),-webkit-transform .4s cubic-bezier(.25,0,0,1)}.overlay.is-open>.dialog{-webkit-transform:translateY(0);transform:translateY(0);opacity:1}.flash{position:absolute;top:0;right:0;bottom:0;left:0;background-image:var(--nimiq-blue-bg);color:#fff;border-radius:4px;margin:8px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;font-weight:200;opacity:0;pointer-events:none}.flash.show{opacity:1;pointer-events:all;-webkit-transition:opacity .3s cubic-bezier(.25,0,0,1);transition:opacity .3s cubic-bezier(.25,0,0,1)}.flash.error{background-image:var(--nimiq-red-bg)}.flash.success{background-image:var(--nimiq-green-bg)}.flash p{font-size:24px;text-align:center;margin:0;opacity:0;-webkit-transform:translateY(24px);transform:translateY(24px)}.flash.show p{padding:24px;opacity:1;-webkit-transform:translateY(0);transform:translateY(0);-webkit-transition:opacity .3s cubic-bezier(.25,0,0,1),-webkit-transform .3s cubic-bezier(.25,0,0,1) .1s;transition:opacity .3s cubic-bezier(.25,0,0,1),-webkit-transform .3s cubic-bezier(.25,0,0,1) .1s;transition:opacity .3s cubic-bezier(.25,0,0,1),transform .3s cubic-bezier(.25,0,0,1) .1s;transition:opacity .3s cubic-bezier(.25,0,0,1),transform .3s cubic-bezier(.25,0,0,1) .1s,-webkit-transform .3s cubic-bezier(.25,0,0,1) .1s}.dialog h2{text-align:center;font-size:24px;line-height:1.2;font-weight:600;padding:32px;margin:0}.close{position:absolute;top:0;right:0;width:24px;height:24px;margin:12px;padding:0;color:var(--nimiq-blue);opacity:.5}.close:hover{opacity:1}.close .nim-icon{display:inline}.recipient{display:-ms-flexbox;display:flex;margin-left:24px;margin-right:24px;padding-bottom:24px;border-bottom:solid 1px var(--nimiq-light-gray)}.recipient .identicon{width:72px;height:72px;margin-right:16px}.recipient .identicon img{width:100%;height:100%}.recipient .address{-ms-flex:1;flex:1;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;color:var(--nimiq-blue);opacity:.5;letter-spacing:.02em}.recipient .address>.chunk{display:block;width:33.3%}.confirm{margin-top:16px;padding:0 24px 24px}.confirm button{display:block;padding:16px;width:100%}.amount{margin-top:24px;font-size:24px;position:relative;margin-left:24px;margin-right:24px}.amount,.amount input{-webkit-box-sizing:border-box;box-sizing:border-box}.amount input{display:block;width:100%;font-family:inherit;font-size:inherit;padding:12px;border:2px solid rgba(31,35,72,.1);color:var(--nimiq-blue);background:0 0;border-radius:8px;outline:0;-webkit-transition:color .2s ease,border .2s ease;transition:color .2s ease,border .2s ease;background-clip:padding-box}.amount input:focus{border-color:rgba(5,130,202,.2)}.amount .ticker{display:block;position:absolute;right:12px;bottom:20px;margin:0;padding:0;font-size:16px;font-weight:600;letter-spacing:.08em;opacity:.4;-webkit-transition:opacity .2s ease-out;transition:opacity .2s ease-out;color:var(--nimiq-light-blue)}.message{margin-top:24px;padding-left:32px;padding-right:32px}.message input{display:block;width:100%;-webkit-box-sizing:border-box;box-sizing:border-box;font-family:inherit;font-size:inherit;padding:12px 0;border:0 none;border-bottom:2px solid rgba(31,35,72,0);color:var(--nimiq-blue);background:0 0;outline:0;-webkit-transition:color .2s ease,border .2s ease;transition:color .2s ease,border .2s ease;background-clip:padding-box;text-align:center}.message input:hover{border-color:rgba(31,35,72,.1)}.message input:focus{border-color:rgba(5,130,202,.2)}"; },
        enumerable: true,
        configurable: true
    });
    return class_2;
}());
export { Checkout as nim_checkout, Donate as nim_donate };
