/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import { HTMLStencilElement, JSXBase } from './stencil.core';
import {
  Network,
  SignedTransaction,
  Theme,
} from './utils/common';

export namespace Components {
  interface NimCheckout {
    /**
    * The name of your app, should be as short as possible.
    */
    'app': string;
    /**
    * Extra data that should be sent with the transaction.
    */
    'data': string;
    /**
    * Transaction fee in luna. Default: 0
    */
    'fee': number;
    /**
    * An image URL. Must be on the same origin as the request is sent from. Should be square and at least 146x146 px.
    */
    'logoUrl': string;
    /**
    * The network you want to use. Can be 'main' or 'test'.
    */
    'network': Network;
    /**
    * The human-readable address of the recipient (your shop/app).
    */
    'recipient': string;
    /**
    * The text to display on the button. Default: "Pay with NIM"
    */
    'text': string;
    /**
    * The theme of the button. Use light when using against dark background.
    */
    'theme': Theme;
    /**
    * Value of the transaction, in Luna. 1 NIM = 100000 Luna.
    */
    'value': number;
  }
  interface NimDonate {
    /**
    * Transaction fee in luna. Default: 0
    */
    'fee': number;
    /**
    * An image URL. Must be on the same origin as the request is sent from. Should be square and at least 146x146 px.
    */
    'logoUrl': string;
    /**
    * The network you want to use. Can be 'main' or 'test'.
    */
    'network': Network;
    /**
    * The human-readable address of the recipient (your shop/app).
    */
    'recipient': string;
    /**
    * The text to display on the button. Default: "Donate NIM"
    */
    'text': string;
    /**
    * The text to display once payment is done. Default: "Thank you for the donation!"
    */
    'thankyou': string;
    /**
    * The theme of the button. Use light when using against dark background.
    */
    'theme': Theme;
  }
}

declare global {


  interface HTMLNimCheckoutElement extends Components.NimCheckout, HTMLStencilElement {}
  const HTMLNimCheckoutElement: {
    prototype: HTMLNimCheckoutElement;
    new (): HTMLNimCheckoutElement;
  };

  interface HTMLNimDonateElement extends Components.NimDonate, HTMLStencilElement {}
  const HTMLNimDonateElement: {
    prototype: HTMLNimDonateElement;
    new (): HTMLNimDonateElement;
  };
  interface HTMLElementTagNameMap {
    'nim-checkout': HTMLNimCheckoutElement;
    'nim-donate': HTMLNimDonateElement;
  }
}

declare namespace LocalJSX {
  interface NimCheckout {
    /**
    * The name of your app, should be as short as possible.
    */
    'app'?: string;
    /**
    * Extra data that should be sent with the transaction.
    */
    'data'?: string;
    /**
    * Transaction fee in luna. Default: 0
    */
    'fee'?: number;
    /**
    * An image URL. Must be on the same origin as the request is sent from. Should be square and at least 146x146 px.
    */
    'logoUrl'?: string;
    /**
    * The network you want to use. Can be 'main' or 'test'.
    */
    'network'?: Network;
    /**
    * Emitted when an error happened during checkout or it is canceled
    */
    'onNimCheckoutError'?: (event: CustomEvent<any>) => void;
    /**
    * Emitted when checkout is successful
    */
    'onNimCheckoutSuccess'?: (event: CustomEvent<SignedTransaction>) => void;
    /**
    * The human-readable address of the recipient (your shop/app).
    */
    'recipient'?: string;
    /**
    * The text to display on the button. Default: "Pay with NIM"
    */
    'text'?: string;
    /**
    * The theme of the button. Use light when using against dark background.
    */
    'theme'?: Theme;
    /**
    * Value of the transaction, in Luna. 1 NIM = 100000 Luna.
    */
    'value'?: number;
  }
  interface NimDonate {
    /**
    * Transaction fee in luna. Default: 0
    */
    'fee'?: number;
    /**
    * An image URL. Must be on the same origin as the request is sent from. Should be square and at least 146x146 px.
    */
    'logoUrl'?: string;
    /**
    * The network you want to use. Can be 'main' or 'test'.
    */
    'network'?: Network;
    /**
    * The human-readable address of the recipient (your shop/app).
    */
    'recipient'?: string;
    /**
    * The text to display on the button. Default: "Donate NIM"
    */
    'text'?: string;
    /**
    * The text to display once payment is done. Default: "Thank you for the donation!"
    */
    'thankyou'?: string;
    /**
    * The theme of the button. Use light when using against dark background.
    */
    'theme'?: Theme;
  }

  interface IntrinsicElements {
    'nim-checkout': NimCheckout;
    'nim-donate': NimDonate;
  }
}

export { LocalJSX as JSX };


declare module "@stencil/core" {
  export namespace JSX {
    interface IntrinsicElements {
      'nim-checkout': LocalJSX.NimCheckout & JSXBase.HTMLAttributes<HTMLNimCheckoutElement>;
      'nim-donate': LocalJSX.NimDonate & JSXBase.HTMLAttributes<HTMLNimDonateElement>;
    }
  }
}


