import { EventEmitter } from '../../stencil.core';
import { Theme, Network, SignedTransaction } from '../../utils/common';
export declare class Checkout {
    inProgress: boolean;
    /**
     * The theme of the button. Use light when using against dark background.
     */
    theme: Theme;
    /**
     * The network you want to use. Can be 'main' or 'test'.
     */
    network: Network;
    /**
     * The name of your app, should be as short as possible.
     */
    app: string;
    /**
     * The human-readable address of the recipient (your shop/app).
     */
    recipient: string;
    /**
     * Value of the transaction, in Luna. 1 NIM = 100000 Luna.
     */
    value: number;
    /**
     * An image URL. Must be on the same origin as the request is sent from. Should be square and at least 146x146 px.
     */
    logoUrl: string;
    /**
     * Transaction fee in luna. Default: 0
     */
    fee: number;
    /**
     * Extra data that should be sent with the transaction.
     */
    data: string;
    /**
     * The text to display on the button. Default: "Pay with NIM"
     */
    text: string;
    /**
     * Emitted when checkout is successful
     */
    nimCheckoutSuccess: EventEmitter<SignedTransaction>;
    /**
     * Emitted when an error happened during checkout or it is canceled
     */
    nimCheckoutError: EventEmitter<any>;
    checkout(): Promise<void>;
    render(): any;
}
