import { Theme, Network } from '../../utils/common';
declare enum Status {
    Idle = 0,
    Progress = 1,
    Success = 2,
    Error = 3
}
export declare class Donate {
    status: Status;
    isOpen: boolean;
    addressChunks: string[];
    identicon: string;
    /**
     * Amount of NIM to donate, bound to input field.
     */
    amount: number;
    /**
     * Message to be attached to transaction, bound to input field.
     */
    message: string;
    /**
     * The theme of the button. Use light when using against dark background.
     */
    theme: Theme;
    /**
     * The network you want to use. Can be 'main' or 'test'.
     */
    network: Network;
    /**
     * The human-readable address of the recipient (your shop/app).
     */
    recipient: string;
    onRecipientChanged(): void;
    /**
     * An image URL. Must be on the same origin as the request is sent from.
     * Should be square and at least 146x146 px.
     */
    logoUrl: string;
    /**
     * Transaction fee in luna. Default: 0
     */
    fee: number;
    /**
     * The text to display on the button. Default: "Donate NIM"
     */
    text: string;
    /**
     * The text to display once payment is done. Default: "Thank you for the donation!"
     */
    thankyou: string;
    componentWillLoad(): void;
    breakAddressIntoChunks(): void;
    generateIdenticon(): void;
    open(): void;
    close(): void;
    donate(event: any): Promise<void>;
    updateAmount(event: any): void;
    updateMessage(event: any): void;
    canConfirm(): boolean;
    render(): any;
}
export {};
