export declare type Theme = 'neutral' | 'blue' | 'gold' | 'light-blue' | 'green' | 'orange' | 'red';
export declare type Network = 'main' | 'test';
export declare const HubUrl: {
    main: string;
    test: string;
};
export interface CheckoutOptions {
    appName: string;
    recipient: string;
    value: number;
    shopLogoUrl?: string;
    fee?: number;
    extraData?: Uint8Array | string;
}
export interface SignedTransaction {
    serializedTx: string;
    hash: string;
    raw: {
        signerPublicKey: Uint8Array;
        signature: Uint8Array;
        sender: string;
        recipient: string;
        value: number;
        fee: number;
        networkId: number;
    };
}
